#!/bin/sh
# We check first that $TESTRTDIR is set?
if [ -z "$TESTRTDIR" ]
then
        echo "TESTRTDIR not defined:"
		echo "Run the .sh script file to set the environment variables."
        echo "In a sh or bash shell (the period ... is part of the command):"
        echo ". <install_dir>/TestRealTime.7.0.0/testrtinit.sh"
else
  # and that the release to patch is a 7.0.0 release?
  ls ${TESTRTDIR}/../TestRealTime.7.0.0/lib  
  if [  $? -ne 0 ]
  then
  	# it is not a 7.0.0 release
  	
  	echo "*********************************************************************"
	echo "*           W A R N I N G ! ! !                                     *"
	echo "* It is not a 7.0.0 release to patch:                               *"
	ls ${TESTRTDIR}/../
	echo "* Patch process is aborted                                          *"
	echo "*********************************************************************"
  	
  else
	# It is a 7.0.0 release
        cp rtrt.common.zlinux.7000_IFIX01.tar  rtrt.zlinux.7000_IFIX01.tar $TESTRTDIR
	cd $TESTRTDIR
	# Untar of each required files.
	# for every platforms
	

	if [ -e "${TESTRTDIR}/lib" ]
	then
	echo "*********************************************************************"
	echo "*    Installation for Common part...                                *"
	echo "*********************************************************************"
	tar xvf rtrt.common.zlinux.7000_IFIX01.tar
	rm rtrt.common.zlinux.7000_IFIX01.tar
	fi
			
	# If LINUX is installed only
	if [ -e "${TESTRTDIR}/bin/s390x" ]
	then
		echo "*********************************************************************"
		echo "*    Installation for ZLINUX part...                                *"
		echo "*********************************************************************"
		tar xvf rtrt.zlinux.7000_IFIX01.tar 
		rm rtrt.zlinux.7000_IFIX01.tar
	fi
	

	echo "*********************************************************************"
	echo "*    Installation Done                                              *"
	echo "*********************************************************************"	
	
  fi # It is a 7.0.0 release

fi # TESTRTDIR is correctly set



