
#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2006 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################


use File::Basename;
use File::Copy;

die "Environment variable TESTRTDIR not found. Exiting.\n" if(!defined($ENV{'TESTRTDIR'})); # NO TRANSLATION
$SCRIPTDIR="$ENV{'TESTRTDIR'}/lib/scripts/";
require $SCRIPTDIR . "Translate.pl";

my $INTDIR=".";
my $pathSeparator;
my $gcc_dir;
my $wtk_dir;
my $edition;
my $assert;
my $configwtk=0;
my $Rose_RT_REG_File ="TestRT-RoseRT.reg" ;

sub quit()
{
	print &PerlTranslate("ConfigureRoseRT.pl", "\nConfiguration is not complete.\n");
	print &PerlTranslate("ConfigureRoseRT.pl", "You can relaunch this configuration script later by using the command:\n");
	print "$BINDIR/TestRTperl -I$ENV{'TESTRTDIR'}/lib/perl ConfigureRoseRT.pl\nor\nConfigureRoseRT.sh\n"; # NO TRANSLATION
	print &PerlTranslate("ConfigureRoseRT.pl", "Confirm quit ? ( y | n )\n");
	$reply=<STDIN>;
	chomp($reply);
	die &PerlTranslate("ConfigureRoseRT.pl", "Quitting\n") if(($reply eq &PerlTranslate("ConfigureRoseRT.pl", "y"))||($reply eq &PerlTranslate("ConfigureRoseRT.pl", "yes")));
}

sub showLog($)
{
	my $log=shift;

	open(IN,"<$log");
	while(<IN>) { print ; }
	close(IN);
}

sub MCheckRoseRT()
{
	my $Status;
	my $gcccmd;
	my $confirm;

	$confirm=0;
	while($confirm==0)
	{


			print &PerlTranslate("ConfigureRoseRT.pl", "\nIf you want to configure the RoseRT plugin and you have RoseRT installed,");
			print &PerlTranslate("ConfigureRoseRT.pl", "\nenter the complete name of the directory containing RoseRT, or q to quit");
			print &PerlTranslate("ConfigureRoseRT.pl", "\nExamples:");
			print &PerlTranslate("ConfigureRoseRT.pl", "\n/projets/Rational/RoseRT/release/RoseRT.2003.06.00\n?\n");
			$gcc_dir=<STDIN>;
			chomp($gcc_dir) ;
			
			my $RoseRT_Home=$gcc_dir . "/bin/registry" ;
			
			if($gcc_dir eq &PerlTranslate("ConfigureRoseRT.pl", "q"))
			{
				quit();
				$gcc_dir="";
			}
			if ( -x $RoseRT_Home )
			{ # Rose RT Found
			    $confirm=1 ;
			    print &PerlTranslate("ConfigureRoseRT.pl", "\nRose RT found in : " . $RoseRT_Home . "\n");
			    my $Reg_File = $ENV{'TESTRTDIR'} . "/bin/sun4/RoseRT/" . $Rose_RT_REG_File ;
			    my @Prog_List = ("cp",$Reg_File,$RoseRT_Home);
			    system(@Prog_List) == 0
				or die "system failed: $?" ;
			    print &PerlTranslate("ConfigureRoseRT.pl", "\ncopy " . $Rose_RT_REG_File . "\nfrom: " . $Reg_File . "\nto: " . $RoseRT_Home . "/" . $Rose_RT_REG_File . " with success\n");

			    if ($gcc_dir =~ /2002.05/)
			    {# Version = 2002.05.xx => Old version => 6.4
			     # Change the TestRT-RoseRT.reg content from 6.4 to 6.5
				patchRoseRT("6.5","6.4",$Reg_File);
			    }
			    else
			    {# Version = 2003.06.xx => New RoseRT release => 6.5 
			     # Keep the TestRT-RoseRT.reg content from 6.4 to 6.5
			     # Nothing to do
			    }
			}
			else
			{
			    print &PerlTranslate("ConfigureRoseRT.pl", "\nRose RT Not found in : " . $RoseRT_Home . "\n");
			}
	} # End of While
	unlink("$INTDIR/output");
	system("/bin/rm -rf output");
	unlink($tmp);
} # End of MCheckRoseRT 

sub patchRoseRT($$$)
{
	my $source=shift;
	my $target=shift;
	my $Reg_File_To_Patch=shift;
	
	print &PerlTranslate("ConfigureRoseRT.pl", "Patching " . $source . " to " . $target . " in " . $Rose_RT_REG_File  . "\n");
	open(IN,"<$Reg_File_To_Patch");
	open(OU,">tmp.txt");
	while(<IN>)
	{
		if(/6.5/)
		{
			s/6.5/6.4/;
		}
		print OU;
	}
	close(IN);
	close(OU);
	rename("tmp.txt",$Reg_File_To_Patch);
} # End of patchRoseRT

sub main()
{
	print &PerlTranslate("ConfigureRoseRT.pl", "Configuration for RoseRT\n");
	print &PerlTranslate("ConfigureRoseRT.pl", "With this configuration process, you have the ability to support the following Rose RealTime:\n");
	print &PerlTranslate("ConfigureRoseRT.pl", "\tRoseRT 2002.05.20\n\tRoseRT 2003.06.00\n");
	
	die &PerlTranslate("ConfigureRoseRT.pl", "Environment variable TESTRTDIR not properly set. Cannot find 'bin/sun4/RoseRT' directory. Exiting.\n") if(! -d "$ENV{'TESTRTDIR'}/bin/sun4/RoseRT");
	my $s=MCheckRoseRT();


} # End of Main

$|=1;
main();

1;
