##!perl -w
#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2005-2006 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################
#TestRTcc.exe perl launcher is located in bin and execute the perl sript TestRTcc.pl located in the lib/scripts
#TestRTcc.pl open the envTestRTcc.pl located in %TEMP%
#a special perl var $TestRTCC is set to 1 allowing to attolcclib to change the behavior.
#the TestRTcc require the generated file to set all vars
#then execute the $TARGETDIR/cmd/attolcc.pl
#So the attolcc.pl call the sub Attolcc located in the attolcclib.pl which can do different thing for TestRTcc command line also used in eclipse 
################################################################################
#$Id: TestRTcc.pl,v 1.12 2006/04/03 12:31:24 build Exp $
################################################################################

## globals ############
$main::TestRTCC=1;
#######################
$main::SCRIPTDIR="$ENV{'TESTRTDIR'}/lib/scripts/";
my $tmpdir=$ENV{'TEMP'};
unless($tmpdir){
	$tmpdir=$ENV{'TMP'};
	unless($tmpdir){
		$tmpdir=$ENV{'HOME'};
	}
}
my $envnode="$tmpdir/envTestRTcc.pl";
if(-f $envnode) {
	require $envnode;
} else {
	print "$envnode not found. Launching command.\n";
	my $ret=system(@ARGV);
	exit($ret);
}

unless($RTRT_ACTIVATED){
# do not print anything when using original command
#	print "No instrumentation required. Launching command.\n" if($ENV{'ATTOLSTUDIO_VERBOSE'});
	my $ret=system(@ARGV);
	exit($ret);
}

if($TARGETDIR) {
	$ENV{'ATLTGT'} =$TARGETDIR;
} else {
	$main::TARGETDIR=$ENV{'ATLTGT'};
}
#print "use TDP $TARGETDIR\n";
die "Environment variable TESTRTDIR not found. Exiting.\n" if(!defined($ENV{'TESTRTDIR'})); # NO TRANSLATION
die "$main::TARGETDIR/cmd/attolcc.pl does not exist !!!\n" unless(-f $main::TARGETDIR . "/cmd/attolcc.pl");

# compute instrum option regarding environment file
require $main::SCRIPTDIR."Fcts.pl";
require $main::SCRIPTDIR."instrum.pl";
$instrumOpt = BuildCCppInstrOptions($TDP_LANGUAGE,"","","");

my $testRTlog=$LOGFILENAME; #attolcc use its own LOGFILENAME format. so memorize it
$LOGFILENAME=$INTDIR.'/'."atlfiles.log";
require $main::TARGETDIR . "/cmd/attolcc.pl";

#translate the log format
if(-f $LOGFILENAME){
	open IN, $LOGFILENAME or die "unable to open the log file $LOGFILENAME\n";
	open OU,">>$testRTlog" or die "unable to write the log file $testRTlog\n";
	while(<IN>){
		if(/^(TSF|FDC|CRC|MET)\s+(.*)$/) {print OU $2,"\n";}
	}
	close IN;
	if( $ATCMODE && !(-f $ATC_TIO_NAME) ){
		print OU  "$ATC_TIO_NAME\n";
		open TMP,">$ATC_TIO_NAME";
		close TMP;
	}
	if( ($ATTMODE || $ATKMODE) && !(-f $TDFFILE) ) {
		print OU  "$TDFFILE\n";
		open TMP,">$TDFFILE";
		close TMP;
	}
	if( ($ATPMODE) && !(-f $ATP_TPF_NAME) ) {
		print OU  "$ATP_TPF_NAME\n";
		open TMP,">$ATP_TPF_NAME";
		close TMP;
	}
	if( ($ATQMODE  ) && !(-f $ATQ_TQF_NAME) ) {
		print OU  "$ATQ_TQF_NAME\n";
		open TMP,">$ATQ_TQF_NAME";
		close TMP;
	}
	close OU;
	unlink($LOGFILENAME);
}
exit(0);

sub TestRTcc_MakeXOBList
{
	opendir(DIR,".") || die "Code Review: Cannot open directory .\n";
	while($d=readdir(DIR)) {
		push(@XOB,$d) if ($d=~/\.xob$/);
	}
	closedir(DIR);
}
