#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2005-2006 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                 -*-  code ckecker Analysis  -*-                              #
#                                                                              #
#                                                                              #
################################################################################
#$Id: codeChecker.pl,v 1.20 2006/04/03 12:31:24 build Exp $
################################################################################


sub codeChecker_cc($)
{
	my ($src)=@_;
	print &PerlTranslate("codeChecker.pl", "%1: Code checking...\n", "%1 is the name of the file to be analized", $src);
	my ($d,$n,$e)=SplitFileName($src);
	my $command="crccc \"$src\" \"$INTDIR/$n.xob\" atus_c.def atl.opp -RULE=\"$MISRA_CONF\"";
	$command.=" -checksysinclude" if($CHECK_SYS_INC);
	$command.=" -incl=\"".join("\",\"",@COMPLETE_INCLUDE_DIR_LIST)."\"" if(@COMPLETE_INCLUDE_DIR_LIST);
	$command.=" -define=\"".join("\",\"",@GENERATION_CONDITION)."\"" if(@GENERATION_CONDITION);
	my $ret = SystemP($command);
	return "" if($ret);
	open ( LOG, ">>$LOGFILENAME" ) or die &PerlTranslate("codeChecker.pl", "Cannot open log file: %1\n", "%1 is the reason given by the Operating System", $!);
	print  LOG "XOB $INTDIR/$n.xob\n";
	close( LOG );
	return "$INTDIR/$n.xob";
}

sub codeChecker_link()
{
        print &PerlTranslate("codeChecker.pl", "%1: Code checking report...\n", "%1 is the name of the file to be analized", $NAME);
	if(-f "$TARGETDIR/cmd/namingRuleCheck.pl"){ #customer checking the naming rule
		require "$TARGETDIR/cmd/namingRuleCheck.pl";
		my $nrxob=namingRuleCheck(@XOB);
		push(@XOB,$nrxob) if($nrxob);
	}
	my $command="crcld -crc=\"$OUTDIR/$NAME.crc\" \"".join("\" \"",@XOB)."\" -RULE=\"$MISRA_CONF\"";
	$command.= " -TEST" if($ATOMODE || $ATUMODE || $ATSMODE);
	my $ret = SystemP($command);
	if($ret) {
	     print &PerlTranslate("codeChecker.pl", "Code checking report generation failed.($ret)\n");
	     return "";
	}
	open ( LOG, ">>$LOGFILENAME" ) or die &PerlTranslate("codeChecker.pl", "Cannot open log file: %1\n", "%1 is the reason given by the Operating System", $!);
	print  LOG "CRC $OUTDIR/$NAME.crc\n";
	close( LOG );
	return "$OUTDIR/$NAME.crc";
}

1;
