
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2006 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------


--------------------------------------------------------------------------
-- $Revision: 1.5 $
-- $Descr: Ada95 package: Ada.Finalization$
--------------------------------------------------------------------------
--
-- Ada95 Source Definition,
-- From LRM Ada95 7.6 - User-Defined Assignment and Finalization
-- Modified to handle Implementation Dependent Definitions
--
--------------------------------------------------------------------------
with RTRT_Imp95 ;

package Ada.Finalization is

   pragma Preelaborate(Finalization);

   type Controlled is abstract tagged private;

   procedure Initialize(Object : in out Controlled);
   procedure Adjust                 (Object : in out Controlled);
   procedure Finalize               (Object : in out Controlled);

   type Limited_Controlled is abstract tagged limited private;

   procedure Initialize(Object : in out Limited_Controlled);
   procedure Finalize  (Object : in out Limited_Controlled);

private

   type Controlled is 
     abstract new RTRT_Imp95.t_Ada_Finalization_Controlled 
     with null record ;

   type Limited_Controlled is
     abstract new RTRT_Imp95.t_Ada_Finalization_Limited_Controlled
     with null record ;

end Ada.Finalization;
--
--------------------------------------------------------------------------
