
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2006 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------


--------------------------------------------------------------------------------
-- Copyright (c) 2003 Rational Software Corporation. All rights reserved.     --
--                                                                            --
--                Product: Rational(R) Test RealTime                          --
--                                                                            --
--      Product Component: All                                                --
--                                                                            --
--               Language: Ada                                                --
--                                                                            --
--        Product version:                                                    --
--                                                                            --
-- Target Deployment Port: adagnat                                            --
--                         Ada95 Gnat                                         --
--                                                                            --
--                   File: attol_tag.adb                                      --
--                         UniTesting part of TDP for Ada                     --
--                                                                            --
-- Rational, the Rational logo are registered trademarks of                   --
-- Rational Software Corporation.                                             --
--                                                                            --
-- The placing of the copyright notices on Rational source code is not        --
-- intended to mean that they are published works, but are included in the    --
-- event of inadvertent publication. The source code of Rational contains     --
-- trade secrets and other valuable confidential information of Rational      --
-- Software Corporation. Rational Software Corporation and its licensors      --
-- retain ownership to Rational Products in both source and object code       --
-- format, and related documentation and all rights therein including         --
-- copyrights, patents and trade secrets.                                     --
--                                                                            --
--                                                                            --
-- U.S. Government Rights                                                     --
--                                                                            --
-- Use, duplication, or disclosure by the U.S. Government is subject to       --
-- restrictions set forth in the applicable Rational License Agreement        --
-- and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS                 --
-- 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,       --
-- or FAR 52.227-14, as applicable.                                           --
--                                                                            --
-- Unless otherwise agreed to in writing, use of Rational products is         --
-- governed by the Rational Product License Agreement provided with           --
-- the product.                                                               --
--------------------------------------------------------------------------------

-------------------------------------------------------------------------------
-- $Revision: 1.10 $
-- $Descr: Ada95 extension for Ada95 TDP$
-------------------------------------------------------------------------------
--
-- Ada95 Specific part for Tag support of attol package.
--
-------------------------------------------------------------------------------

with attol_serv ;
with attol_comm ;
with attol_link ;

use attol_serv;
use attol_comm;

package body Attol_Tag is

  use type Attol.ModeValid,Attol.ModeCheck,Attol.Attol_Int;

  procedure check_tag(t1,t2:ada.tags.tag;
                      error : in out Attol.Attol_int) is
  begin
    if ada.tags."/="(t1,t2) then
      error := 1;
    end if;
  end;

  -- edv on tags
  procedure edv_ada(CheckMode   :       in      Attol.ModeCheck   ;
                    valeur      :       in      ada.tags.tag      ;
                    numero      :       in      Attol.attol_int   ;
                    ev          :       in      ada.tags.tag      ;
                    valid       :       in      Attol.ModeValid := Attol.StdValue) is
    ok:boolean;
  begin
    ok:=ada.tags."="(valeur,ev);
    if ((not Attol.mode_tab) or ((CheckMode = Attol.Check) and ((not ok)or (valid/=Attol.StdValue)))) then
      put('V');
      Attol.Put_Var_Line_Beginning(numero);
      put(ada.tags.external_tag(valeur));
      if ((CheckMode = Attol.UnCheck) or ((ok)and (valid=Attol.StdValue))) Then
        put(" RA=T");
      else
        put(" RA=F");
        Attol.resultat_global:=false;
      end if;
      if (CheckMode = Attol.Check) then
        put(" MI=");
        put(ada.tags.external_tag(ev));
        put(" MA=");
        put(ada.tags.external_tag(ev));
      end if;
      put_line(Attol.rio);
    end if; -- mode_tab
  end; -- edv on tags

  procedure Put_WChar_In_Rio(Valeur : in wide_Character) is
  begin
    put_dec_image (wide_character'pos(valeur));
  end; -- procedure Put_WChar_In_Rio;

procedure put_Wstring(valeur: in wide_string) is
  in_str : boolean := false;
begin
  if valeur'first > valeur'last then
    put ("""""");
  else
    for i in valeur'first .. valeur'last loop
--NU:
      if i>STRING_MAX_LEN then
        put("...");
        exit;
      elsif (valeur(i) < ' ') or (valeur(i) > '~') then 
        if (in_str) then 
          put ("""&\0");
        else
          if (i = valeur'first) then put ("\0");
          else                       put ("&\0");
          end if;
        end if;
        in_str := false;
      else
        if (not in_str) then
          if (i = valeur'first) then put ("""");
          else                       put ("&""");
          end if;
        end if;
        if valeur(i) ='"' then put("""""");
        else put(character'val(wide_character'pos(valeur(i))));
        end if;
        in_str := true;
      end if;
    end loop;
    if (in_str) then
      put('"');
    end if;
  end if;
end put_Wstring;

  -- wide_character
  procedure edv_ada(CheckMode   :       in      ModeCheck       ;
                    valeur      :       in      wide_character       ;
                    numero      :       in      attol_int       ;
                    min         :       in      wide_character       ;
                    max         :       in      wide_character       ;
                          valid     :     in    ModeValid := StdValue) is
  begin
    if ((valid/=StdValue) or (not mode_tab) or ((CheckMode = Check) and (Valeur not in Min .. max))) then
      put('V');
      Put_Var_Line_Beginning(numero);
      Put_WChar_In_Rio(Valeur);
      if ((CheckMode = UnCheck) or ((Valeur in Min .. max)and then (valid=StdValue))) Then
        put(" RA=T");
      else
        put(" RA=F");
        resultat_global:=false;
     end if;
      if ((CheckMode = Check)and then (valid = StdValue)) then
        put(" MI=");
        Put_WChar_In_Rio(Min);
        put(" MA=");
        Put_WChar_In_Rio(Max);
      end if;
      put_line(rio);
    end if; -- mode_tab
  end edv_ada; -- _wide_character
  -- wide_string
  procedure edv_ada(CheckMode   :       in      ModeCheck       ;
                    valeur      :       in      wide_string          ;
                    numero      :       in      attol_int       ;
                    min         :       in      wide_string          ;
                    max         :       in      wide_string          ;
                          valid     :     in    ModeValid := StdValue) is
  begin
    if ((valid/=StdValue) or (not mode_tab) or ((CheckMode = Check) and ((valeur<min) or (valeur>max)))) then
      put('V');
      Put_Var_Line_Beginning(numero);
      put_Wstring(valeur);
      if ((Checkmode = UnCheck) or ((((valeur>=min) and (valeur<=max)))and then (valid=StdValue))) then
        put(" RA=T");
      else
        put(" RA=F");
        resultat_global:=false;
      end if;
      if ((CheckMode = Check)and then (valid = StdValue)) then
        put(" MI=");
        put_Wstring(min);
        put(" MA=");
        put_Wstring(max);
      end if;
      put_line(rio);
    end if; -- mode_tab
  end edv_ada; -- wide_string

  -- wide_string 
  procedure ptu_ada(valeur      :       in      wide_string          ;
                    numero      :       in      attol_int       ;
                    base        :       in      attol_int:=10   ) is
  begin
    if (not Mode_Tab) then
      put('N');
      Put_Var_Line_Beginning(numero);
      put_Wstring(valeur);
      put_line(rio);
    end if;
  end ptu_ada;

  -- wide_character
  procedure ptu_ada(valeur      :       in      wide_character       ;
                    numero      :       in      attol_int       ;
                    base        :       in      attol_int:=10   ) is
  begin
    if (not Mode_Tab) then
      put('N');
      Put_Var_Line_Beginning(numero);
      Put_WChar_In_Rio(Valeur);
      put_line(rio);
    end if;
 end ptu_ada;




end Attol_Tag;
