

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2006 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
* $Id: atu.c,v 1.38 2006/03/14 16:14:58 rfrance Exp $
* $Descr: Unit Testing Library Source (included by TP.c[pp]) $
*******************************************************************************/

#ifdef _ATL_EXIT_PENDING
RTRT_STATICFCT void atu_exit_pending (
#if !RTRT_KR
void
#endif
)
{
#ifdef ATU_EXIT_PENDING
   ATU_EXIT_PENDING
#endif
}
#else /* _ATL_EXIT_PENDING */
RTRT_STATICFCT void atu_late_exit (
#if !RTRT_KR
void
#endif
)
{
#ifdef ATU_LATE_EXIT
   ATU_LATE_EXIT
#endif
}
#endif /* _ATL_EXIT_PENDING */

RTRT_STATICFCT void atu_early_init (
#if !RTRT_KR
void
#endif
)
{
#ifdef ATU_EARLY_INIT
   ATU_EARLY_INIT
#endif
}

#define ATU_ABS(x) ((x) < 0 ? -(x) : (x))

RTRT_STATICVAR int _atu_current_level;
RTRT_STATICVAR int _atu_array_mode;
RTRT_STATICVAR int _atu_global_result;
RTRT_STATICVAR atu_integer _atu_local_variable_num;
RTRT_STATICVAR int _atu_constant_mode;
RTRT_STATICVAR int _atu_stub_num;
RTRT_STATICVAR int _atu_stub_result;
RTRT_STATICVAR int _atu_stub_min;
RTRT_STATICVAR int _atu_stub_max;
RTRT_STATICVAR _ATU_LARGEST_INT _atu_start_time;

#ifndef NIL
atu_charstring NIL;
#endif

#ifndef NONIL
atu_pointer NONIL;
#endif

#if USE_ATC || USE_ATP || USE_ATQ || USE_ATT
RTRT_STATICVAR char *_atu_name_current_op;
RTRT_STATICVAR char *_atu_name_current_test;
RTRT_STATICVAR int _atu_num_current_op;
RTRT_STATICVAR int _atu_num_current_test;
RTRT_STATICVAR int _atu_obs_tool_flag;
RTRT_STATICVAR int _atu_testError;
RTRT_STATICVAR int _atu_fileError;
#define _ATU_SETERROR _atu_testError=1;
#else
#define _ATU_SETERROR
#endif

#if ATU_BREAK_ON_TEST_FAILED
#define _ATU_TESTERROR _ATU_SETERROR priv_check_failed ();
#else
#define _ATU_TESTERROR _ATU_SETERROR
#endif /* ATU_BREAK_ON_TEST_FAILED */

#if USE_ATT
#if RTRT_CPLUSPLUS_LANGUAGE
extern "C" {
#endif
#if !RTRT_KR
RTRT_GLOBALFCT void _att_print_change_instance ( RTRT_U_INT32 instance_id );
#else
RTRT_GLOBALFCT void _att_print_change_instance ( );
#endif
#if RTRT_CPLUSPLUS_LANGUAGE
} // end of extern "C"
#endif
#endif /* USE_ATT */

#if RTRT_FLOAT_DUMP
#if !RTRT_KR
RTRT_STATICFCT void priv_dump_csts(void)
#else
RTRT_STATICFCT void priv_dump_csts()
#endif
{
#if RTRT_FLOAT
  atl_line_add("F1 ");
  atl_line_inc(float_image((float)   3.14159265358979323846, atl_line_cur));
  atl_line_dump();
  atl_line_add("F2 ");
  atl_line_inc(double_image((double) 3.14159265358979323846, atl_line_cur));
  atl_line_dump();
#endif /* RTRT_FLOAT */
}
#endif /* RTRT_FLOAT_DUMP */

#if RTRT_CPLUSPLUS_LANGUAGE

#define CONCAT_STR_C      ATTOL_RUN::CONCAT_STR_CPP

#define START_CHRONO_C    ATTOL_RUN::START_CHRONO_CPP
#define STOP_CHRONO_C     ATTOL_RUN::STOP_CHRONO_CPP
#define EDV_CHRONO_MUET_C ATTOL_RUN::EDV_CHRONO_MUET_CPP

#define START_C           ATTOL_RUN::START_CPP
#define STOP_C            ATTOL_RUN::STOP_CPP

#define DCL_OP_C          ATTOL_RUN::DCL_OP_CPP
#define DCL_TST_C         ATTOL_RUN::DCL_TST_CPP
#define DCL_FAC_REP_C     ATTOL_RUN::DCL_FAC_REP_CPP

#define SET_MODE_TAB_C    ATTOL_RUN::SET_MODE_TAB_CPP
#define SET_MODE_CST_C    ATTOL_RUN::SET_MODE_CST_CPP

#define UNSET_MODE_TAB_C  ATTOL_RUN::UNSET_MODE_TAB_CPP
#define UNSET_MODE_CST_C  ATTOL_RUN::UNSET_MODE_CST_CPP

#define ATTOL_OPEN_BRA_C  ATTOL_RUN::OPEN_BRA_CPP
#define ATTOL_CLOSE_BRA_C ATTOL_RUN::CLOSE_BRA_CPP

#define RUPT              ATTOL_RUN::RUPT_CPP

#define PTU_CHAR_C        ATTOL_RUN::PTU_CHAR_CPP
#define PTU_INTEGER_C     ATTOL_RUN::PTU_INTEGER_CPP
#define PTU_UNSIGNED_C    ATTOL_RUN::PTU_UNSIGNED_CPP
#define PTU_FLOAT_C       ATTOL_RUN::PTU_FLOAT_CPP
#define PTU_DOUBLE_C      ATTOL_RUN::PTU_DOUBLE_CPP
#define PTU_BOOLEAN_C     ATTOL_RUN::PTU_BOOLEAN_CPP

#define INI_STR_C         ATTOL_RUN::INI_STR_CPP

#define EDV_STR_C         ATTOL_RUN::EDV_STR_CPP
#define EDV_POINTER_C     ATTOL_RUN::EDV_POINTER_CPP
#define EDV_UNSIGNED_C    ATTOL_RUN::EDV_UNSIGNED_CPP
#define EDV_CHAR_C        ATTOL_RUN::EDV_CHAR_CPP
#define EDV_INTEGER_C     ATTOL_RUN::EDV_INTEGER_CPP
#define EDV_FLOAT_C       ATTOL_RUN::EDV_FLOAT_CPP
#define EDV_DOUBLE_C      ATTOL_RUN::EDV_DOUBLE_CPP

#endif

#if RTRT_STRING

#if !RTRT_KR
RTRT_STATICFCT int atu_comp_3_str(atu_charstring minin, atu_charstring vain, atu_charstring maxin)
#else
RTRT_STATICFCT int atu_comp_3_str(minin, vain, maxin)
atu_charstring minin;
atu_charstring vain;
atu_charstring maxin;
#endif
{
  int res;
  int i, j;

  res = 1;
  if ((vain == NIL) || (minin == NIL) || (maxin == NIL))
    {
      if ((vain == NIL) && (minin == NIL) && (maxin == NIL))
        {
          res = 1;
        }
      else
        {
          res = 0;
        }
    }
  else
    {
      i = 0;
      while (((minin[i]) == (vain[i])) && ((vain[i]) == (maxin[i])) && ((minin[i]) != '\0'))
        {
          i++;
        }
      j = i;
      while ((minin[i]) == (vain[i]) && ((minin[i]) != '\0'))
        {
          i++;
        }
      while ((maxin[j]) == (vain[j]) && ((maxin[j]) != '\0'))
        {
          j++;
        }
      if (((minin[i]) <= (vain[i])) && ((vain[j]) <= (maxin[j])))
        {
          res = 1;
        }
      else
        {
          res = 0;
        }
    }
  return(res);
}


#if RTRT_STR_CONCAT_SUPPORTED

RTRT_STATICVAR char _atu_string_pool[3][ATU_STRING_SIZE+1];
RTRT_STATICVAR int  _atu_string_num;

#if !RTRT_KR
char * CONCAT_STR_C(atu_charstring str, ...)
#else
char * CONCAT_STR_C(va_alist)
va_dcl
#endif
{
  va_list t;
  int len;

#if !RTRT_KR
  const char * ptr;
  va_start(t, str);
  ptr = str;
#else
  char * ptr;
  va_start(t);
  ptr = va_arg(t, char *);
#endif

  len = 0;
  while (ptr)
    {
      while((*ptr) && (len < ATU_STRING_SIZE))
        {
          _atu_string_pool[_atu_string_num][len] = *ptr;
          ptr++;
          len++;
        }
      ptr = va_arg(t, char *);
    }
  _atu_string_pool[_atu_string_num][len] = 0;
  va_end(t);
  return(_atu_string_pool[_atu_string_num++]);
}

#endif /* RTRT_STR_CONCAT_SUPPORTED */

#endif /* RTRT_STRING */

#if !RTRT_KR
RTRT_STATICFCT void _atu_init_static(void)
#else
RTRT_STATICFCT void _atu_init_static()
#endif
{
  _atu_current_level = 1024;
#if !RTRT_RAM_CLEAN
  _atu_array_mode = 0;
  _atu_global_result = 0;
  _atu_local_variable_num = 0;
  _atu_constant_mode = 0;
  _atu_stub_num=0;
  _atu_stub_result=0;
  _atu_stub_min=0;
  _atu_stub_max=0;
#if RTRT_STRING
#if RTRT_STR_CONCAT_SUPPORTED
  _atu_string_num=0;
#endif
#endif

#if !RTUT_NOT_INIT_NIL
  NIL = (atu_charstring)(0);
#endif

#if USE_ATC || USE_ATP || USE_ATQ || USE_ATT
  _atu_name_current_op = (char *) 0;
  _atu_name_current_test = (char *) 0;
  _atu_num_current_op =0;
  _atu_num_current_test =0;
  _atu_obs_tool_flag =0;
#endif
#endif
#if !RTUT_NOT_INIT_NONIL
  NONIL = (atu_pointer)(RTUT_NONIL_VALUE);
#endif

}

#if !RTRT_KR
void PTU_CHAR_C(char value, int num)
#else
void PTU_CHAR_C(value, num)
char value;
int num;
#endif
{
  atl_line_add_char('N');
  atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
  atl_line_add(" '");
  atl_line_inc(char_image(value, atl_line_cur));
  atl_line_add("'");
  atl_line_dump();
}

#if !RTRT_KR
void PTU_INTEGER_C(atu_integer value, int num, int base)
#else
void PTU_INTEGER_C(value, num, base)
atu_integer value;
int num, base;
#endif
{
  atl_line_add_char('N');
  atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
  atl_line_add_char(' ');
  atl_line_inc(integer_image_10((_ATU_LARGEST_INT)value, atl_line_cur));
  atl_line_dump();
}

#if !RTRT_KR
void PTU_UNSIGNED_C(atu_unsigned value, int num, int base)
#else
void PTU_UNSIGNED_C(value, num, base)
atu_unsigned value;
int num, base;
#endif
{
  atl_line_add_char('N');
  atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
  atl_line_add_char(' ');
  atl_line_inc(unsigned_image_10(value, atl_line_cur));
  atl_line_dump();
}

#if !RTRT_KR
void PTU_BOOLEAN_C(int value, int num)
#else
void PTU_BOOLEAN_C(value, num)
int value;
int num;
#endif
{
  atl_line_add_char('N');
  atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
  atl_line_add_char(' ');
  if (value)
    {
      atl_line_add("TRUE");
    }
  else
    {
      atl_line_add("FALSE");
    }
  atl_line_dump();
}

#if RTRT_FLOAT

#if !RTRT_KR
void PTU_FLOAT_C(float value, int num)
#else
void PTU_FLOAT_C(value, num)
float value;
int num;
#endif
{
  atl_line_add_char('N');
  atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
  atl_line_add_char(' ');
  atl_line_inc(float_image(value, atl_line_cur));
  atl_line_dump();
}

#if !RTRT_KR
void PTU_DOUBLE_C(double value, int num)
#else
void PTU_DOUBLE_C(value, num)
double value;
int num;
#endif
{
  atl_line_add_char('N');
  atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
  atl_line_add_char(' ');
  atl_line_inc(double_image(value, atl_line_cur));
  atl_line_dump();
}

#endif /* RTRT_FLOAT */

#if RTRT_STRING

#if !RTRT_KR
void EDV_STR_C(int aff_interv, int uncheck, atu_charstring value, int num, atu_charstring value_min, atu_charstring value_max)
#else
void EDV_STR_C(aff_interv, uncheck, value, num, value_min, value_max)
int aff_interv, uncheck;
atu_charstring value;
int num;
atu_charstring value_min;
atu_charstring value_max;
#endif
{
  aff_interv=0;
  if (value)
    {

      if (_atu_constant_mode)
        {
          atl_line_add_char('J');
          atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_constant_mode, atl_line_cur));
          atl_line_add(" \"");
	      atl_buffer_string_image (value);
          atl_line_add("\"");
          atl_line_dump();
        }

      if (_atu_array_mode)
        {
          _atu_local_variable_num++;
          if (uncheck || (atu_comp_3_str(value_min, value, value_max)))
            {
            }
          else
            {
	      _ATU_TESTERROR
              _atu_global_result = 0;
              atl_line_add_char('X');
              atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_local_variable_num, atl_line_cur));
              atl_line_add(" \"");
              atl_buffer_string_image (value);
              atl_line_add("\" RA=F");

              if (!uncheck)
                {
                  if (value_min == NIL)
                    {
                      atl_line_add(" MI=NIL");
                    }
                  else
                    {
                      atl_line_add(" MI=\"");
                      atl_buffer_string_image (value_min);
                      atl_line_add_char('"');
                    }
                  if (value_max == NIL)
                    {
                      atl_line_add(" MA=NIL");
                    }
                  else
                    {
                      atl_line_add(" MA=\"");
		              atl_buffer_string_image (value_min);
                      atl_line_add_char('"');
                    }
                }

              atl_line_dump();
            }
        }
      else
        {
          atl_line_add_char('V');
          atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
          atl_line_add(" \"");
	  atl_buffer_string_image (value);
          if (uncheck || (atu_comp_3_str(value_min, value, value_max)))
            {
              atl_line_add("\" RA=T");
            }
          else
            {
	      _ATU_TESTERROR
              atl_line_add("\" RA=F");
            }

          if (!uncheck)
            {
              if (value_min == NIL)
                {
                  atl_line_add(" MI=NIL");
                }
              else
                {
                  atl_line_add(" MI=\"");
		          atl_buffer_string_image (value_min);
                  atl_line_add_char('"');
                }
              if (value_max == NIL)
                {
                  atl_line_add(" MA=NIL");
                }
              else
                {
                  atl_line_add(" MA=\"");
		          atl_buffer_string_image (value_max);
                  atl_line_add_char('"');
                }
            }

          atl_line_dump();
        }
    }
  else
    {

      if (_atu_constant_mode)
        {
          atl_line_add_char('J');
          atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_constant_mode, atl_line_cur));
          atl_line_add(" NIL");
          atl_line_dump();
        }

      if (_atu_array_mode)
        {
          _atu_local_variable_num++;
          if (uncheck || (atu_comp_3_str(value_min, value, value_max)))
            {
            }
          else
            {
              _atu_global_result = 0;
	          _ATU_TESTERROR
              atl_line_add_char('X');
              atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_local_variable_num, atl_line_cur));
              atl_line_add(" NIL RA=F");
              if (value_min == NIL)
                {
                  atl_line_add(" MI=NIL");
                }
              else
                {
                  atl_line_add(" MI=\"");
		          atl_buffer_string_image (value_min);
                  atl_line_add_char('"');
                }
              if (value_max == NIL)
                {
                  atl_line_add(" MA=NIL");
                }
              else
                {
                  atl_line_add(" MA=\"");
		          atl_buffer_string_image (value_max);
                  atl_line_add_char('"');
                }
              atl_line_dump();
            }
        }
      else
        {
          atl_line_add_char('V');
          atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
          atl_line_add(" NIL");
          if (uncheck || (atu_comp_3_str(value_min, value, value_max)))
            {
              atl_line_add(" RA=T");
            }
          else
            {
	          _ATU_TESTERROR
              atl_line_add(" RA=F");
              if (value_min == NIL)
                {
                  atl_line_add(" MI=NIL");
                }
              else
                {
                  atl_line_add(" MI=\"");
		          atl_buffer_string_image (value_min);
                  atl_line_add_char('"');
                }
              if (value_max == NIL)
                {
                  atl_line_add(" MA=NIL");
                }
              else
                {
                  atl_line_add(" MA=\"");
		          atl_buffer_string_image (value_max);
                  atl_line_add_char('"');
                }
            }
          atl_line_dump();
        }
    }
#if RTRT_STR_CONCAT_SUPPORTED
  _atu_string_num = 0;
#endif
}

#endif /* RTRT_STRING */

#if !RTRT_KR
void EDV_CHAR_C(int aff_interv, int uncheck, char value, int num, char value_min, char value_max)
#else
void EDV_CHAR_C(aff_interv, uncheck, value, num, value_min, value_max)
int aff_interv, uncheck, num;
char value, value_min, value_max;
#endif
{
  aff_interv=0;

  if (_atu_constant_mode)
    {
      atl_line_add_char('J');
      atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_constant_mode, atl_line_cur));
      atl_line_add(" '");
      atl_line_inc(char_image(value, atl_line_cur));
      atl_line_add("'");
      atl_line_dump();
    }

  if (_atu_array_mode)
    {
      _atu_local_variable_num++;
      if (uncheck || ((value >= value_min) && (value <= value_max)))
        {
        }
      else
        {
          _atu_global_result = 0;
	      _ATU_TESTERROR
          atl_line_add_char('X');
          atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_local_variable_num, atl_line_cur));
          atl_line_add(" '");
          atl_line_inc(char_image(value, atl_line_cur));
          atl_line_add("' RA=F");

          if (!uncheck)
            {
              atl_line_add(" MI='");
              atl_line_inc(char_image(value_min, atl_line_cur));
              atl_line_add("' MA='");
              atl_line_inc(char_image(value_max, atl_line_cur));
              atl_line_add("'");
            }
          atl_line_dump();
        }
    }
  else
    {
      atl_line_add_char('V');
      atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
      atl_line_add(" '");
      atl_line_inc(char_image(value, atl_line_cur));
      if (uncheck || ((value >= value_min) && (value <= value_max)))
        {
          atl_line_add("' RA=T");
        }
      else
        {
	      _ATU_TESTERROR
          atl_line_add("' RA=F");
        }

      if (!uncheck)
        {
          atl_line_add(" MI='");
          atl_line_inc(char_image(value_min, atl_line_cur));
          atl_line_add("' MA='");
          atl_line_inc(char_image(value_max, atl_line_cur));
          atl_line_add("'");
        }
      atl_line_dump();
    }
}

#if !RTRT_KR
void EDV_INTEGER_C(int aff_interv, int uncheck, atu_integer value, int num, int base, atu_integer value_min, atu_integer value_max)
#else
void EDV_INTEGER_C(aff_interv, uncheck, value, num, base, value_min, value_max)
int  aff_interv, uncheck, num, base;
atu_integer value, value_min, value_max;
#endif
{
  aff_interv=0;

  if (_atu_constant_mode)
    {
      atl_line_add_char('J');
      atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_constant_mode, atl_line_cur));
      atl_line_add_char(' ');
      atl_line_inc(integer_image_10((_ATU_LARGEST_INT)value, atl_line_cur));
      atl_line_dump();
    }

  if (_atu_array_mode)
    {
      _atu_local_variable_num++;
      if (uncheck || ((value >= value_min) && (value <= value_max)))
        {
        }
      else
        {
          _atu_global_result = 0;
	      _ATU_TESTERROR
          atl_line_add_char('X');
          atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_local_variable_num, atl_line_cur));
          atl_line_add_char(' ');
          atl_line_inc(integer_image_10((_ATU_LARGEST_INT)value, atl_line_cur));
          atl_line_add(" RA=F");

          if (!uncheck)
            {
              atl_line_add(" MI=");
              atl_line_inc(integer_image_10((_ATU_LARGEST_INT)value_min, atl_line_cur));
              atl_line_add(" MA=");
              atl_line_inc(integer_image_10((_ATU_LARGEST_INT)value_max, atl_line_cur));
            }

          atl_line_dump();
        }
    }
  else
    {
      atl_line_add_char('V');
      atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
      atl_line_add_char(' ');
      atl_line_inc(integer_image_10((_ATU_LARGEST_INT)value, atl_line_cur));
      if (uncheck || ((value >= value_min) && (value <= value_max)))
        {
          atl_line_add(" RA=T");
        }
      else
        {
	  _ATU_TESTERROR
          atl_line_add(" RA=F");
        }

      if (!uncheck)
        {
          atl_line_add(" MI=");
          atl_line_inc(integer_image_10((_ATU_LARGEST_INT)value_min, atl_line_cur));
          atl_line_add(" MA=");
          atl_line_inc(integer_image_10((_ATU_LARGEST_INT)value_max, atl_line_cur));
        }

      atl_line_dump();
    }
}

#if !RTRT_KR
void EDV_UNSIGNED_C(int aff_interv, int uncheck, atu_unsigned value, int num, int base, atu_unsigned value_min, atu_unsigned value_max)
#else
void EDV_UNSIGNED_C(aff_interv, uncheck, value, num, base, value_min, value_max)
int  aff_interv, uncheck, num, base;
atu_unsigned value, value_min, value_max;
#endif
{
  aff_interv=0;

  if (_atu_constant_mode)
    {
      atl_line_add_char('J');
      atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_constant_mode, atl_line_cur));
      atl_line_add_char(' ');
      atl_line_inc(unsigned_image_10(value, atl_line_cur));
      atl_line_dump();
    }

  if (_atu_array_mode)
    {
      _atu_local_variable_num++;
      if (uncheck || ((value >= value_min) && (value <= value_max)))
        {
        }
      else
        {
          _atu_global_result = 0;
	      _ATU_TESTERROR
          atl_line_add_char('X');
          atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_local_variable_num, atl_line_cur));
          atl_line_add_char(' ');
          atl_line_inc(unsigned_image_10(value, atl_line_cur));
          atl_line_add(" RA=F");

          if (!uncheck)
            {
              atl_line_add(" MI=");
              atl_line_inc(unsigned_image_10(value_min, atl_line_cur));
              atl_line_add(" MA=");
              atl_line_inc(unsigned_image_10(value_max, atl_line_cur));
            }

          atl_line_dump();
        }
    }
  else
    {
      atl_line_add_char('V');
      atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
      atl_line_add_char(' ');
      atl_line_inc(unsigned_image_10(value, atl_line_cur));
      if (uncheck || ((value >= value_min) && (value <= value_max)))
        {
          atl_line_add(" RA=T");
        }
      else
        {
	      _ATU_TESTERROR
          atl_line_add(" RA=F");
        }

      if (!uncheck)
        {
          atl_line_add(" MI=");
          atl_line_inc(unsigned_image_10(value_min, atl_line_cur));
          atl_line_add(" MA=");
          atl_line_inc(unsigned_image_10(value_max, atl_line_cur));
        }

      atl_line_dump();
    }
}

#if !RTRT_KR
void EDV_BOOLEAN_C(int aff_interv, int uncheck, int value, int num, int value_min, int value_max)
#else
void EDV_BOOLEAN_C(aff_interv, uncheck, value, num, value_min, value_max)
int aff_interv, uncheck, num;
int value, value_min, value_max;
#endif
{
  aff_interv=0;

  if (_atu_constant_mode)
    {
      atl_line_add_char('J');
      atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_constant_mode, atl_line_cur));
      atl_line_add_char(' ');
      if (value)
        {
          atl_line_add("TRUE");
        }
      else
        {
          atl_line_add("FALSE");
        }
      atl_line_dump();
    }

  if (_atu_array_mode)
    {
      _atu_local_variable_num++;
      if (uncheck || ((value >= value_min) && (value <= value_max)))
        {
        }
      else
        {
          _atu_global_result = 0;
	      _ATU_TESTERROR
          atl_line_add_char('X');
          atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_local_variable_num, atl_line_cur));
          atl_line_add_char(' ');
          if (value)
            {
              atl_line_add("TRUE");
            }
          else
            {
              atl_line_add("FALSE");
            }
          atl_line_add(" RA=F");

          if (!uncheck)
            {
              atl_line_add(" MI=");
              if (value_min)
                {
                  atl_line_add("TRUE");
                }
              else
                {
                  atl_line_add("FALSE");
                }
              atl_line_add(" MA=");
              if (value_max)
                {
                  atl_line_add("TRUE");
                }
              else
                {
                  atl_line_add("FALSE");
                }
            }

          atl_line_dump();
        }
    }
  else
    {
      atl_line_add_char('V');
      atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
      atl_line_add_char(' ');
      if (value)
        {
          atl_line_add("TRUE");
        }
      else
        {
          atl_line_add("FALSE");
        }
      if (uncheck || ((value >= value_min) && (value <= value_max)))
        {
          atl_line_add(" RA=T");
        }
      else
        {
	      _ATU_TESTERROR
          atl_line_add(" RA=F");
        }

      if (!uncheck)
        {
          atl_line_add(" MI=");
          if (value_min)
            {
              atl_line_add("TRUE");
            }
          else
            {
              atl_line_add("FALSE");
            }
          atl_line_add(" MA=");
          if (value_max)
            {
              atl_line_add("TRUE");
            }
          else
            {
              atl_line_add("FALSE");
            }
        }

      atl_line_dump();
    }
}

#if !RTRT_KR
void EDV_POINTER_C(int aff_interv, int uncheck, atu_pointer value, int num, atu_pointer value_att)
#else
void EDV_POINTER_C(aff_interv, uncheck, value, num, value_att)
int aff_interv, uncheck;
atu_pointer value;
int num;
atu_pointer value_att;
#endif
{

#ifdef RTRT_NO_DOUBLE_CONVERSION
  _ATU_POINTER_CONVERSION convert_value = (_ATU_POINTER_CONVERSION) value;
#else
#define convert_value (_ATU_POINTER_CONVERSION) value
#endif

  aff_interv=0;

  if (_atu_constant_mode)
    {
      atl_line_add_char('J');
      atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_constant_mode, atl_line_cur));
      atl_line_add_char(' ');
      atl_line_inc(unsigned_image_10((atu_unsigned) convert_value, atl_line_cur));
      atl_line_dump();
    }

  if (_atu_array_mode)
    {
      _atu_local_variable_num++;
      if (uncheck || ((value == value_att) || ((value != (atu_pointer)0) && (value_att == (atu_pointer)NONIL))))
        {
        }
      else
        {
          _atu_global_result = 0;
	      _ATU_TESTERROR
          atl_line_add_char('X');
          atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_local_variable_num, atl_line_cur));
          atl_line_add_char(' ');
          atl_line_inc(unsigned_image_10((atu_unsigned) convert_value, atl_line_cur));
          atl_line_add(" RA=F");
          atl_line_dump();
        }
    }
  else
    {
      atl_line_add_char('V');
      atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
      atl_line_add_char(' ');
      atl_line_inc(unsigned_image_10((atu_unsigned) convert_value, atl_line_cur));
      if (uncheck || ((value == value_att) || ((value != (atu_pointer)0) && (value_att == (atu_pointer)NONIL))))
        {
          atl_line_add(" RA=T");
        }
      else
        {
	  _ATU_TESTERROR
          atl_line_add(" RA=F");
        }
      atl_line_dump();
    }
}

#if RTRT_FLOAT

#if !RTRT_KR
void EDV_FLOAT_C(int aff_interv, int uncheck, float value, int num, float value_min, float value_max)
#else
void EDV_FLOAT_C(aff_interv, uncheck, value, num, value_min, value_max)
int aff_interv, uncheck;
int num;
float value, value_min, value_max;
#endif
{
  aff_interv=0;

  if (_atu_constant_mode)
    {
      atl_line_add_char('J');
      atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_constant_mode, atl_line_cur));
      atl_line_add_char(' ');
      atl_line_inc(float_image(value, atl_line_cur));
      atl_line_dump();
    }

  if (_atu_array_mode)
    {
      _atu_local_variable_num++;
      if (uncheck|| ((value >= (value_min - ATU_ABS(value_min) * _ATL_EPSILON_FLT)) && (!(value > (value_max + ATU_ABS(value_max) * _ATL_EPSILON_FLT)))))
        {
        }
      else
        {
          _atu_global_result = 0;
	      _ATU_TESTERROR
          atl_line_add_char('X');
          atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_local_variable_num, atl_line_cur));
          atl_line_add_char(' ');
          atl_line_inc(float_image(value, atl_line_cur));
          atl_line_add(" RA=F");

          if (!uncheck)
            {
              atl_line_add(" MI=");
              atl_line_inc(float_image(value_min, atl_line_cur));
              atl_line_add(" MA=");
              atl_line_inc(float_image(value_max, atl_line_cur));
            }

          atl_line_dump();
        }
    }
  else
    {
      atl_line_add_char('V');
      atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
      atl_line_add_char(' ');
      atl_line_inc(float_image(value, atl_line_cur));
      if (uncheck || ((value >= (value_min - ATU_ABS(value_min) * _ATL_EPSILON_FLT)) && (value <= (value_max + ATU_ABS(value_max) * _ATL_EPSILON_FLT))))
        {
          atl_line_add(" RA=T");
        }
      else
        {
	      _ATU_TESTERROR
          atl_line_add(" RA=F");
        }

      if (!uncheck)
        {
          atl_line_add(" MI=");
          atl_line_inc(float_image(value_min, atl_line_cur));
          atl_line_add(" MA=");
          atl_line_inc(float_image(value_max, atl_line_cur));
        }

      atl_line_dump();
    }
}

#if !RTRT_KR
void EDV_DOUBLE_C(int aff_interv, int uncheck, double value, int num, double value_min, double value_max)
#else
void EDV_DOUBLE_C(aff_interv, uncheck, value, num, value_min, value_max)
int aff_interv, uncheck;
double value, value_min, value_max;
int num;
#endif
{
  aff_interv=0;

  if (_atu_constant_mode)
    {
      atl_line_add_char('J');
      atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_constant_mode, atl_line_cur));
      atl_line_add_char(' ');
      atl_line_inc(double_image(value, atl_line_cur));
      atl_line_dump();
    }

  if (_atu_array_mode)
    {
      _atu_local_variable_num++;
      if (uncheck || ((value >= (value_min - ATU_ABS(value_min) * _ATL_EPSILON_DBL)) && (!(value > (value_max + ATU_ABS(value_max) * _ATL_EPSILON_DBL)))))
        {
        }
      else
        {
          _atu_global_result = 0;
	      _ATU_TESTERROR
          atl_line_add_char('X');
          atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_local_variable_num, atl_line_cur));
          atl_line_add_char(' ');
          atl_line_inc(double_image(value, atl_line_cur));
          atl_line_add(" RA=F");

          if (!uncheck)
            {
              atl_line_add(" MI=");
              atl_line_inc(double_image(value_min, atl_line_cur));
              atl_line_add(" MA=");
              atl_line_inc(double_image(value_max, atl_line_cur));
            }

          atl_line_dump();
        }
    }
  else
    {
      atl_line_add_char('V');
      atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
      atl_line_add_char(' ');
      atl_line_inc(double_image(value, atl_line_cur));
      if (uncheck || ((value >= (value_min - ATU_ABS(value_min) * _ATL_EPSILON_DBL)) && (value <= (value_max + ATU_ABS(value_max) * _ATL_EPSILON_DBL))))
        {
          atl_line_add(" RA=T");
        }
      else
        {
	      _ATU_TESTERROR
          atl_line_add(" RA=F");
        }

      if (!uncheck)
        {
          atl_line_add(" MI=");
          atl_line_inc(double_image(value_min, atl_line_cur));
          atl_line_add(" MA=");
          atl_line_inc(double_image(value_max, atl_line_cur));
        }
      atl_line_dump();
    }
}

#endif /* RTRT_FLOAT */

#if !RTRT_KR
void DCL_OP_C(int num, const char *name_op)
#else
void DCL_OP_C(num, name_op)
int        num;
char        *name_op;
#endif
{
  _atu_array_mode = 0;
  _atu_constant_mode = 0;
  _atu_global_result = 1;
  _atu_local_variable_num = 0;
  atl_line_add_char('O');
  atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
  atl_line_dump();
#if USE_ATC || USE_ATP || USE_ATQ || USE_ATT
  if (!_atu_obs_tool_flag)
    {
      /* Obstools dump */
      _atu_name_current_test = 0;
      _atu_name_current_op = (char *) "Initialization";
      _atu_obs_tool_flag = 1;
#if USE_ATC || USE_ATP || USE_ATQ
      /* Obstools dump */
      _atl_obstools_dump(1);
#endif
    }
  _atu_name_current_op=(char *)name_op;
  _atu_num_current_op=num;
#endif
}


#if USE_ATT
void _atu_test_failed()
{

 if(_atu_testError)
 { /* print the result of the previous test */
  _atu_fileError=_atu_testError;
  _atu_testError=0;
  _atl_tdf_line(_ATO_STYLE_CHECK_KO);
  _atl_tdf_note_string("Test error");
  _att_print_change_instance ( 0 );
 }
}
#endif


#if !RTRT_KR
void DCL_TST_C(int num, const char *name_tst)
#else
void DCL_TST_C(num, name_tst)
int        num;
char        *name_tst;
#endif
{
  _atu_array_mode = 0;
  _atu_constant_mode = 0;
  _atu_global_result = 1;
  _atu_local_variable_num = 0;
  atl_line_add_char('T');
  atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
  atl_line_dump();
#if USE_ATC || USE_ATP || USE_ATQ || USE_ATT
  _atu_name_current_test=(char *)name_tst;
  _atu_num_current_test=num;
#if USE_ATT
  _atu_test_failed();
  /* Print the NO line containing current test */
  _atl_tdf_note_string_3 ( _atu_name_current_test, (char *)"/", _atu_name_current_op );
  _att_print_change_instance ( 0 );
#endif
#endif
}

#if !RTRT_KR
void START_C(void)
#else
void START_C()
#endif
{
  char *date;
  atl_early_init();
  _atu_init_static();
  date=priv_date();
  if(date)
  {
	  atl_line_add("H0 ");
	  atl_line_add(date);
      atl_line_dump();
  }
#if RTRT_FLOAT_DUMP
  priv_dump_csts();
#endif
#if USE_ATT
_atu_testError=0;
_atu_fileError=0;
#endif
}

#if !RTRT_KR
void STOP_C(void)
#else
void STOP_C()
#endif
{
#if USE_ATC || USE_ATP || USE_ATQ || USE_ATT
  /* Obstools dump */
  _atu_num_current_op++;
  _atu_num_current_test++;
  _atu_name_current_test = 0;
  _atu_name_current_op = (char *) "Termination";
#if USE_ATT
  _atu_test_failed();
  if(_atu_fileError)
  { /* print the result of the last test */
    _atl_tdf_line(_ATO_STYLE_CHECK_KO);
    _atl_tdf_note_string("Error detected");
    _att_print_change_instance ( 0 );
  }
#endif
  /* mark the end of the test */
  atl_line_add("tdp end");
  atl_line_dump();

#if USE_ATC || USE_ATP || USE_ATQ
  /* Obstools dump */
  _atl_obstools_dump(1);
#endif
#endif
  atl_exit();
}

#if !RTRT_KR
void UNSET_MODE_TAB_C(int num)
#else
void UNSET_MODE_TAB_C(num)
int num;
#endif
{
  _atu_array_mode = 0;
  atl_line_add_char('A');
  atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
  if (_atu_global_result)
    {
      atl_line_add(" OK RA=T");
    }
  else
    {
      _ATU_TESTERROR
      atl_line_add(" BAD RA=F");
    }
  atl_line_dump();
}

#if RTRT_STRING

#define INCORRECT_STR_INIT " !! ? !!"

#if !RTRT_KR
void INI_STR_C(char * s, int aff_val, long num, atu_charstring val)
#else
void INI_STR_C(s, aff_val, num, val)
char * s;
int  aff_val;
long num;
atu_charstring val;
#endif
{
  int i;

  if (s)
    {
      if (!val) val = "?";
      for (i=0; val[i]; i++) s[i] = val[i];
      s[i] = '\0';
#if RTRT_STR_CONCAT_SUPPORTED
      _atu_string_num = 0;
#endif
      if (aff_val)
        {
          atl_line_add_char('N');
          atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
          atl_line_add(" \"");
          atl_buffer_string_image (s);
          atl_line_add_char('"');
          atl_line_dump();
        }
      else
        {
        }
    }
  else
    {
      atl_line_add_char('N');
      atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
      atl_line_add(INCORRECT_STR_INIT);
      atl_line_dump();
    }
}

#endif /* RTRT_STRING */

#if !RTRT_KR
void RUPT (int niveau)
#else
void RUPT (niveau)
int niveau;
#endif
{
  if (niveau < _atu_current_level)
    {
      _atu_current_level = niveau;
      atl_line_add_char('Z');
      atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)niveau, atl_line_cur));
      atl_line_add_char(' ');
      atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_local_variable_num, atl_line_cur));
      atl_line_dump();
    }
}

#if !RTRT_KR
void DCL_FAC_REP_C(int num, int facteur)
#else
void DCL_FAC_REP_C(num, facteur)
int num;
int facteur;
#endif
{
  atl_line_add_char('R');
  atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
  atl_line_add_char(' ');
  atl_line_inc(integer_image_10((_ATU_LARGEST_INT)facteur, atl_line_cur));
  atl_line_dump();
}

#if !RTRT_KR
void SET_MODE_CST_C(int num)
#else
void SET_MODE_CST_C(num)
int num;
#endif
{
  _atu_constant_mode = num;
}

#if !RTRT_KR
void UNSET_MODE_CST_C(int num)
#else
void UNSET_MODE_CST_C(num)
int num;
#endif
{
  _atu_constant_mode = 0;
  atl_line_add_char('J');
  atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
  atl_line_add(" *");
  atl_line_dump();
}

#if !RTRT_KR
void ATTOL_OPEN_BRA_C(int num)
#else
void ATTOL_OPEN_BRA_C(num)
int num;
#endif
{
  atl_line_add_char('J');
  atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
  atl_line_add(" [");
  atl_line_dump();
}

#if !RTRT_KR
void ATTOL_CLOSE_BRA_C(int num)
#else
void ATTOL_CLOSE_BRA_C(num)
int num;
#endif
{
  atl_line_add_char('J');
  atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
  atl_line_add(" ]");
  atl_line_dump();
}

#if !RTRT_KR
void EDV_CHRONO_MUET_C( int stub, int a_status, int num_app)
#else
void EDV_CHRONO_MUET_C( stub, a_status, num_app)
  int stub;
  int a_status;
  int num_app;
#endif
{
  if (_atu_stub_num)
    {
      if ((stub!=_atu_stub_num)||(_atu_stub_result!=a_status))
        {
          atl_line_add_char('L');
          atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_stub_num, atl_line_cur));
          atl_line_add_char(' ');
          if (_atu_stub_result)
            {
              atl_line_add_char('N');
            }
          else
            {
              atl_line_add_char('O');
            }
          atl_line_add_char(' ');
          atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_stub_min, atl_line_cur));
          atl_line_add_char(' ');
          atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_stub_max, atl_line_cur));
          atl_line_dump();
          _atu_stub_num=stub;
          _atu_stub_result=a_status;
          _atu_stub_min=num_app;
          _atu_stub_max=num_app;
        }
      else
        {
          _atu_stub_max=num_app;
        }
    }
  else
    {
       _atu_stub_num=stub;
       _atu_stub_result=a_status;
       _atu_stub_min=num_app;
       _atu_stub_max=num_app;
    }
}

#if !RTRT_KR
void EDV_MUET_CHECK( int stub, int ind)
#else
void EDV_MUET_CHECK( stub, ind)
  int stub;
  int ind;
#endif
{
  atl_line_add_char('M');
  atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)stub, atl_line_cur));
  atl_line_add_char(' ');
  atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)ind, atl_line_cur));
  atl_line_dump();
}

#if !RTRT_KR
int COMP_STR_C (atu_charstring s1, atu_charstring s2)
#else
int COMP_STR_C (s1, s2)
atu_charstring s1;
atu_charstring s2;
#endif
{
  if (s1 && s2)
    {
      while ((*s1) && (*s2))
        {
          if ((*s1) != (*s2))
            {
              return(1);
            }
          s1++;
          s2++;
        }
      if ((*s1) || (*s2))
        {
          return(1);
        }
      return(0);
    }
  return(1);
}

#if !RTRT_KR
RTRT_STATICFCT _ATU_LARGEST_INT atu_clock(void)
#else
RTRT_STATICFCT _ATU_LARGEST_INT atu_clock()
#endif
{
  RTRT_CLOCK_TYPE now;

  priv_clock(&now);
  return (_ATU_LARGEST_INT) RTRT_CLOCK_TO_UNITS (now);
}

#if !RTRT_KR
void STOP_CHRONO_C(void)
#else
void STOP_CHRONO_C()
#endif
{
  _ATU_LARGEST_INT stop_time;

  stop_time = atu_clock();
  if (_atu_stub_num)
    {
      EDV_CHRONO_MUET_C( 0, 0, 0);
    }
#if RTRT_CLOCK != RTRT_NONE
#ifdef RTRT_KR
      atl_line_add("D");
      atl_line_add(RTRT_UNIT_TYPE_FORMAT);
      atl_line_add(" ");
#else
      atl_line_add("D" RTRT_UNIT_TYPE_FORMAT " ");
#endif
      atl_line_inc(integer_image_10((_ATU_LARGEST_INT)stop_time-_atu_start_time-RTUT_DELAY, atl_line_cur));
      atl_line_dump();
#endif
  if (( _atu_array_mode != 0) ||(  _atu_global_result != 1) ||(  _atu_local_variable_num != 0))
    {
      atl_line_add("W0 Warning: Internal runtime variables modified by code under Test");
      atl_line_dump();
    }

  _atu_array_mode = 0;
  _atu_global_result = 1;
  _atu_local_variable_num = 0;

#if USE_ATC || USE_ATP || USE_ATQ
  /* Obstools dump */
  _atl_obstools_dump(1);
#endif /* USE_ATC || USE_ATP || USE_ATQ */
}

#if !RTRT_KR
void START_CHRONO_C(void)
#else
void START_CHRONO_C()
#endif
{
  _atu_array_mode = 0;
  _atu_global_result = 1;
  _atu_local_variable_num = 0;
  _atu_start_time = atu_clock();
}

#if !RTRT_KR
void SET_MODE_TAB_C(int num)
#else
void SET_MODE_TAB_C(num)
int num;
#endif
{
  _atu_array_mode = 1;
  _atu_global_result = 1;
  _atu_local_variable_num = 0;
  _atu_current_level = 1024;

  atl_line_add_char('B');
  atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
  atl_line_dump();
}

#if RTRT_CPLUSPLUS_LANGUAGE

void ATTOL_RUN::EXCEP_CPP(int num, const char *param)
{
  atl_line_add_char('W');
  atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
  if ((param) && (param[0]))
    {
    atl_line_add_char(' ');
    atl_buffer_string_image (param);
    }
  atl_line_dump();
}

void ATTOL_RUN::ERV_CPP(int num)
{
  _ATU_TESTERROR
  if (_atu_array_mode)
    {
      _atu_local_variable_num++;
      atl_line_add("W4");
      atl_line_dump();
      atl_line_add_char('X');
      atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_local_variable_num, atl_line_cur));
      atl_line_add(" ?");
      atl_line_add(" RA=F");
      atl_line_dump();
      _atu_global_result = 0;
    }
  else
    {
      atl_line_add("W4");
      atl_line_dump();
      atl_line_add_char('V');
      atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)num, atl_line_cur));
      atl_line_add(" ? RA=F");
      atl_line_dump();
    }
}

void ATTOL_RUN::EDV_LST_ITEM_NOT_FOUND_CPP(const char * expected_value, int num)
{
  _ATU_TESTERROR
  _atu_local_variable_num++;
  _atu_global_result = 0;
  atl_line_add_char('Y');
  atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_local_variable_num, atl_line_cur));
  atl_line_add(" ?");
  atl_line_add(" RA=F");
  atl_line_add(" MI=");
  if (expected_value && *expected_value) atl_buffer_string_image (expected_value);
  else  atl_line_add("?");
  atl_line_add(" MA=");
  if (expected_value && *expected_value) atl_buffer_string_image(expected_value);
  else  atl_line_add("?");
  atl_line_dump();
}

void ATTOL_RUN::EDV_LST_TEST_ITEM_CPP(const char * expected_value, _atl_bool result, int num)
{
  _atu_local_variable_num++;
  if (!result)
    {
      _atu_global_result = 0;
      _ATU_TESTERROR
      atl_line_add_char('Y');
      atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_local_variable_num, atl_line_cur));
      atl_line_add(" #");
      atl_line_add(" RA=F");
      atl_line_add(" MI=");
      if (expected_value && *expected_value) atl_buffer_string_image(expected_value);
      else  atl_line_add("?");
      atl_line_add(" MA=");
      if (expected_value && *expected_value) atl_buffer_string_image(expected_value);
      else  atl_line_add("?");
      atl_line_dump();
    }
}

void ATTOL_RUN::EDV_LST_ITEM_NOT_EXPECTED_CPP(int num)
{
  _ATU_TESTERROR
  _atu_local_variable_num++;
  _atu_global_result = 0;
  atl_line_add_char('Y');
  atl_line_inc(unsigned_image_10((_ATU_LARGEST_INT)_atu_local_variable_num, atl_line_cur));
  atl_line_add(" !");
  atl_line_add(" RA=F");
  atl_line_add(" MI=?");
  atl_line_add(" MA=?");
  atl_line_dump();
}

#endif

